]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- 1.517: add %tcl_version/%tcl_sitearch/%tcl_sitelib
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
46763914 11# compiler version
69bcfbf3 12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 14
69bcfbf3 15%__rm /bin/rm --interactive=never
36eccf0d 16
33040789 17# Build system path macros.
69bcfbf3
ER
18%__autoconf autoconf %{?debug:-Wall}
19%__automake automake -a -c -f --foreign
20%__autopoint autopoint --force
21
22# add parallel build flags: -jN
a5656a95 23#
0b810bc6
JR
24# if you want to disable parallel build do (replace %% with %)
25# echo '%%_smp_mflags %%{nil}' >> ~/.rpmmacros
a5656a95
JR
26#
27%__make make %{?_smp_mflags}
28%__scons scons %{?_smp_mflags}
29%__waf waf %{?_smp_mflags}
30%__cmake cmake %{?_smp_mflags}
31
32%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
33 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 34
83094b62 35%__gettextize { \
8a995cff 36 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 37 gettextize --copy --force --no-changelog; \
97589b6e 38 else \
3241033b 39 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
40 fi; \
41 if [ ! -f po/Makevars ]; then \
3241033b 42 cp -f po/Makevars{.template,}; \
8a995cff 43 fi; \
8a995cff 44}
f93109a0 45
46%__glib_gettextize glib-gettextize --copy --force
47%__gnome_doc_common gnome-doc-common --copy
fb59e475 48%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 49%__gtkdocize gtkdocize --copy
50%__intltoolize intltoolize --copy --force
c26f1b59 51%__libtoolize libtoolize --copy --force --install
33040789 52
384e1b2b 53# Path to top of build area.
f5f7156a 54%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
384e1b2b 55
81e450f7
ER
56# The number of cvs changelog entries kept when building package.
57%_buildchangelogtruncate 20
58
6a5eda77 59%dependencytracking %{nil}
3241033b 60
e5da9169
ER
61# Relations between package names that cause dependency loops
62# with legacy packages that cannot be fixed. Relations are
63# specified as
64# p>q
65# where package p has a Requires: on something that package q Provides:
66#
67# XXX Note: that there cannot be any whitespace within the string "p>q",
68# and that both p and q are package names (i.e. no version/release).
69%_dependency_whiteout %{nil}
70
810fa5c4 71#-----------------------------------------------------------------
72#
73# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
74# BuildRequires: awk
75# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 76#
77# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 78# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
79# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 80# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 81# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 82#
83# Regular expressions are supported, but to avoid some character be treated
84# as regular expression it must be escaped twice.
85
86%filter_out \
7b6f1112 87 for (i = 1; i in I; i++) { A=0; \
810fa5c4 88 for (f in F) { \
89 if (I[i] ~ "^" F[f] "$") A=1; \
90 }; \
91 if (!A) printf(I[i] FS); \
92 }
93
94%rpmcflags %(awk 'BEGIN {
95 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 96 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 97 %{filter_out}
98}')
99
100%rpmcxxflags %(awk 'BEGIN {
09a90176 101 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
102 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 103 %{filter_out}
104}')
105
98e7f050
AM
106%rpmcppflags %(awk 'BEGIN {
107 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
108 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
109 %{filter_out}
110}')
111
810fa5c4 112%rpmldflags %(awk 'BEGIN {
c05a0741 113 split("%{?optldflags}",I);
810fa5c4 114 split("%{?filterout_ld}",F)
115 %{filter_out}
116}')
117
25f52d1a 118# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
119# but, don't use it, better use gcc as linker
120%ld_rpmldflags %(awk 'BEGIN {
121 split("%{rpmldflags}",F);
122 for (f in F) {
123 s = F[f];
124 if (s ~ /^-Wl,/) {
125 s = substr(s,5);
126 gsub(/,/," ",s);
127 };
128 printf(s FS);
129 };
130}')
131
8ef644e5 132#-----------------------------------------------------------------
133#
134# Generate a command which cleans environment, leaving only the
135# most important variables.
136# If any spec requires any additional environment it should
137# redefine %_preserve_env in following manner:
138#
139# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 140# %define _preserve_env ADDITIONAL_VAR
8ef644e5 141
57ba0f59 142%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 143
bb597f2b
AM
144# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
145%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 146 split("%{?_preserve_env}", P);
a363d727
ER
147 for (i in P) {
148 p = P[i];
82d10503
ER
149 if (!ENVIRON[p] || d[p]) {
150 continue;
8ef644e5 151 }
82d10503
ER
152 d[p] = 1;
153 split(ENVIRON[p], V, "");
154 val = p "=";
155 for (j = 1; j in V; j++) {
156 v = V[j];
157 if (v == q)
158 v = qq;
159 else if (v == "\\"")
160 v = q2q;
161 else if (v == "\\\\")
162 v = "\\\\\\\\";
163 else
164 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
165 val = val "" v;
166 }
167 printf(val " ");
8ef644e5 168 }
169}')
170
9c404149 171#-----------------------------------------------------------------
9f4ce098 172%configure2_13 { \
9c404149
AM
173 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
174 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
175 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 176 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 177 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 178 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 179 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
180 %{?__cc:CC="%{__cc}" ; export CC ; } \
181 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 182 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 183 --host=%{_target_platform} \
9c404149
AM
184 --prefix=%{_prefix} \
185 --exec-prefix=%{_exec_prefix} \
186 --bindir=%{_bindir} \
187 --sbindir=%{_sbindir} \
188 --sysconfdir=%{_sysconfdir} \
189 --datadir=%{_datadir} \
190 --includedir=%{_includedir} \
191 --libdir=%{_libdir} \
192 --libexecdir=%{_libexecdir} \
193 --localstatedir=%{_localstatedir} \
194 --sharedstatedir=%{_sharedstatedir} \
195 --mandir=%{_mandir} \
196 --infodir=%{_infodir} \
b6c5da52 197 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 198 %{dependencytracking} \
9c404149
AM
199}
200
89f4ca1f 201%__cmake /usr/bin/cmake
39b9534b
ER
202%cmake { \
203CC="%{__cc}" \
204CXX="%{__cxx}" \
205CFLAGS="%{rpmcflags}" \
206CXXFLAGS="%{rpmcxxflags}" \
12513dc1 207LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
208%{__cmake} \
209}
210
211# override __scons to add -j4 in your ~/.rpmmacros for parallel make
212%__scons /usr/bin/scons
213%scons { \
214%{__scons} \
5c76736d
ER
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
216 CFLAGS="${CFLAGS:-%rpmcflags}" \
217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
218 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 219 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
220 %{?__cc:CC="%{__cc}"} \
221 %{?__cxx:CXX="%{__cxx}"} \
222 libsuffix=%{_lib} \
223 prefix=%{_prefix} \
39b9534b
ER
224}
225
6339d32d 226# waf. see waf.spec
89f4ca1f 227# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
228%__waf /usr/bin/waf
229%waf { \
6339d32d
ER
230CC="%{__cc}" \
231CXX="%{__cxx}" \
9e244007 232CPP="%{__cpp}" \
6339d32d
ER
233CFLAGS="%{rpmcflags}" \
234CXXFLAGS="%{rpmcxxflags}" \
235%{__waf} \
6339d32d
ER
236}
237
4a6b0d54 238#----------------------------------------------------------------
9bacbb5b 239#%configure_cache 0
fe6c4bdd 240%configure_cache_file %{buildroot}.configure.cache
73f832b3 241
e84cd836 242%configure {./configure \
4a6b0d54
AF
243 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
244 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 245 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 246 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 247 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 248 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
249 %{?__cc:CC="%{__cc}"} \
250 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 251 --host=%{_target_platform} \
4a6b0d54
AF
252 --build=%{_target_platform} \
253 --prefix=%{_prefix} \
254 --exec-prefix=%{_exec_prefix} \
255 --bindir=%{_bindir} \
256 --sbindir=%{_sbindir} \
257 --sysconfdir=%{_sysconfdir} \
258 --datadir=%{_datadir} \
259 --includedir=%{_includedir} \
260 --libdir=%{_libdir} \
261 --libexecdir=%{_libexecdir} \
262 --localstatedir=%{_localstatedir} \
263 --sharedstatedir=%{_sharedstatedir} \
264 --mandir=%{_mandir} \
265 --infodir=%{_infodir} \
b6c5da52 266 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 267 %{dependencytracking} \
9bacbb5b 268 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
269}
270
b3b1397b
ER
271# overload to insert debuginfo package
272%prep \
273%if 0%{?_enable_debug_packages}\
274%{debug_package}\
275%endif\
276%%prep\
277%{nil}
278
9c404149 279# Location of autoconf macros
7f0f4a79 280%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 281
e2804f99 282# Location of omf files
7f0f4a79 283%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 284
e987a186 285# Location of pkgconfig files
9a4e877a 286%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
287# noarch pkgconfig files
288%_npkgconfigdir /usr/share/pkgconfig
e987a186 289
486b0b5f 290# Location of desktop files
291%_desktopdir /usr/share/applications
86dff2d0 292%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 293
481463e9 294# Location of pixmaps for applnk/desktop files
e1f0a822 295%_pixmapsdir /usr/share/pixmaps
9c404149 296
481463e9 297# Location of themable icons for applnk/desktop files
b36c8e2a 298%_iconsdir /usr/share/icons
299
e987a186
JB
300# Location of fonts directories
301%_fontsdir /usr/share/fonts
302
b3282f3f 303# Location of Gtk and associated libraries documentation
fe6c4bdd 304%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 305
fc4d7771 306# Location of KDE documentation
fe6c4bdd 307%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 308
5869828c 309# unsermake script
310%__unsermake /usr/share/unsermake/unsermake
311
9c404149 312# Current date
8cf161e2 313%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 314
9c404149
AM
315# Example files, programs, scripts...
316%_examplesdir /usr/src/examples
317
c8f7e820 318# Alternative kernel type/version
261729d9 319%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 320
8377d27d 321# The directory holding Linux kernel sources
261729d9 322%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 323
9c404149 324# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 325%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 326
8bf3719d 327
f5f7156a
ER
328%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
329%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
330%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
730239f9
ER
331%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
332%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
333%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 334
410df6e8
ER
335# Requires name = version-release
336%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 337# Requires: name = version
91d2f1eb 338%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 339# Requires: name = version (version based on querying package %2)
0d3e64c0 340%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 341
c94807f3 342%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 343
344# kernel version-release handling
95125403
ER
345%__kernel_ver %{expand:%%global __kernel_ver %( \\
346 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
347 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
348 echo ${Z:-ERROR}; \\
1a7d3518 349)}%__kernel_ver
95125403 350
c94807f3
ER
351%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
352%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
353%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
354%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 355
6262f001
ER
356# `uname -r` to be used in @release field
357%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
358
e00dd7f6 359# sgml macros
3241033b
ER
360%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
361%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
362%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
363%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
364%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
365%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 366%docbook_sgmlcat_fix() { for l in \
367'' \
368' -- default decl --' \
369'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
370' -- hacks for opensp --' \
371'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
372'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
373'' \
374; do echo $l; done >> %1 \
375}
376
eea64748
ER
377# vim - "
378
4f044018
ER
379# minimum file size needed for compressed documents.
380# just smaller files than this get larger when compressed.
a88ae20f
ER
381# some stats:
382# - 0 byte file compressed was 25 bytes .gz
383# - 39 byte file was compressed as 57
384# - with test/test.spec@man 158 byte file was compressed also 158
385%_min_compress_bytes 159
4f044018 386
9c404149
AM
387#-----------------------------------------------------------------
388# find and gzip all files in %{_mandir} and %{infodir}
389#
390# Requires: xargs, find
391#
392#%no_install_post_compress_docs 1
393%__spec_install_post_compress_docs { \
53d5af13 394%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 395 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 396 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 397 echo "Compress man pages: $i"; \
4f044018
ER
398 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
399 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
400 find $RPM_BUILD_ROOT$i -type l | while read a; do \
401 m=$(readlink $a); \
402 rm -f $a; \
403 echo .so ${m##*/} > $a; \
404 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
405 done; \
4f044018 406 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
407 fi; \
408 done; \
728ad671
JB
409 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
410 echo "Compress info pages: %{_infodir}"; \
411 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
412 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
413 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 414 fi; \
53d5af13 415}; __spec_install_post_compress_docs } }
9c404149
AM
416
417#-----------------------------------------------------------------
418# Strip executable binaries and shared object files
419#
420# Requires: find, awk, strip, cut, xargs
421#
a2ad2754
JB
422# Special macros which affect this process:
423#%no_install_post_strip 1 # disable stripping at all
424#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
425#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
426#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
427#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
428#
9c404149 429%__spec_install_post_strip {%{!?debug: \
53d5af13 430%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 431if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
432 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
433 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
434 if [ "$modulelist" ]; then \
435 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 436 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
437 echo "$modulelist" | xargs -l512 chmod u+w; \
438 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
439 echo "DONE"; \
440 fi; \
eea64748 441 fi; \
0ac49134 442 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
443 if [ -n "$filelist" ]; then \
444 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
445 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
446 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 447 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 448 if [ -n "$elfexelist" ]; then \
4d5370ac 449 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
450 chmod u+w $elfexelist; \
451 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
452 echo "DONE"; \
453 fi; \
454 if [ -n "$elfsharedlist" ]; then \
4d5370ac 455 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
456 chmod u+w $elfsharedlist; \
457 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
458 echo "DONE"; \
459 fi; \
460 if [ -n "$archiveslist" ]; then \
4d5370ac 461 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
462 chmod u+w $archiveslist; \
463 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
464 echo "DONE"; \
465 fi; \
98a06bad 466 fi; \
0ac49134
ER
467 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
468 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
469 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 470 if [ -n "$filelist_all" ]; then \
4d5370ac 471 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 472 chmod u+w $filelist_all; \
f89ccb5f 473 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 474 echo "DONE"; \
9c404149 475 fi; \
f89ccb5f 476 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 477 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 478 chmod u+w $filelist_unneeded; \
f89ccb5f 479 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 480 echo "DONE"; \
8f74418b 481 fi; \
f89ccb5f 482 if [ -n "$filelist_debug" ]; then \
4d5370ac 483 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 484 chmod u+w $filelist_debug; \
f89ccb5f 485 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 486 echo "DONE"; \
9f0d4f36 487 fi; \
53d5af13 488fi; }; __spec_install_post_strip } } }
3241033b 489
fc5d7e20 490#-----------------------------------------------------------------
491# remove all RPATH from executable binaries and shared object files
492#
493# Requires: find, awk, cut, xargs, chrpath, uname
494#
a2ad2754
JB
495# Special macros which affect this process
496#%no_install_post_chrpath 1 # disable chrpath at all
497#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
498#
fc5d7e20 499%__spec_install_post_chrpath {%{!?debug: \
53d5af13 500%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 501if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 502 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 503 if [ -n "$files" ]; then \
d5517264 504 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 505 fi; \
98a06bad 506 if [ -n "$objs" ]; then \
4d5370ac 507 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
508 echo "$objs" | \
509 while read file; do \
510 rpath= ; \
511 chmod u+w "$file"; \
5541bf26 512 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
513 case $dir in \
514 '$ORIGIN' ) \
515 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
516 else rpath="$rpath:$dir" ; fi ; \
517 continue ; \
518 ;; \
519 esac ; \
f9abaddb
AM
520 newdir=$(readlink -m "$dir"); \
521 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
522 case $dir in \
523 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
524 echo "remove-rpath: $dir in $file"; \
525 ;; \
526 * ) \
527 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
528 else rpath="$rpath:$dir" ; fi ; \
529 ;; \
530 esac ; \
531 done ; \
532 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
533 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
534 done; \
535 fi; \
53d5af13 536fi; }; __spec_install_post_chrpath } } }
3241033b 537
d366d7e0
AM
538#-----------------------------------------------------------------
539# Find all shared object files with unresolved symbols. Warn
540# and terminate if any found (termination can be turned off by define).
541#%no_install_post_check_so 1
542%__spec_install_post_check_so { \
543 __spec_install_post_check_so() { \
544 fail=0; \
545 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 546 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 547 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
548 done ; \
549 echo " DONE"; \
14ae3117 550 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
551}; __spec_install_post_check_so }}
552
d72c185f 553#-----------------------------------------------------------------
ccb8ae8d 554# Find and gzip all kernel modules
555#
556# Requires: find
557#
fe6c4bdd 558#%no_install_post_compress_modules 1
ccb8ae8d 559%__spec_install_post_compress_modules { \
53d5af13 560%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 561 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 562 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
563 if [ "$q" ]; then \
564 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
565 echo "$q" | xargs -r %{__gzip} -9nf; \
566 echo "DONE"; \
567 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
568 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
569 fi; \
3241033b 570 fi; \
53d5af13 571}; __spec_install_post_compress_modules } }
9c404149 572
ef64802f
ER
573# Remove common Perl files we don't package
574%__spec_install_post_perl_clean {\
575%{!?no_install_post_perl_clean: \
576%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
577} }
578
83094b62 579#-----------------------------------------------------------------
0e4cb4dd 580# Update GConf2 schemas
83094b62 581#
582# Requires: GConf2
583#
46885239 584%gconf_schema_install() \
307ac6c9
ER
585 umask 022; \
586 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
587 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 588%{nil}
46885239 589
590%gconf_schema_uninstall() \
24336a54 591if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 592 umask 022; \
24336a54
ER
593 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
594 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 595fi; \
f93109a0 596%{nil}
597
598#-----------------------------------------------------------------
599# Update desktop MIME database
c0a4caa0 600# requires: desktop-file-utils
c3bcd10e 601%update_desktop_database() {{ \
f93109a0 602 umask 022; \
fb59e475 603 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
604};} \
605%{nil}
f93109a0 606
c3bcd10e
ER
607%update_desktop_database_post %update_desktop_database
608
609%update_desktop_database_postun() {{ \
f27cf2fd 610if [ "$1" = "0" ]; then \
c00bf95c 611 %update_desktop_database \
f27cf2fd 612fi; \
c00bf95c
MB
613};} \
614%{nil}
f93109a0 615
fb59e475 616#-----------------------------------------------------------------
617# Update shared MIME info database
618# requires: shared-mime-info
619#
c3bcd10e 620%update_mime_database() {{ \
fb59e475 621 umask 022; \
622 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
623};} \
624%{nil}
fb59e475 625
626#-----------------------------------------------------------------
627# Update icon cache
628# requires: gtk+
629#
c3bcd10e 630%update_icon_cache() {{ \
fb59e475 631 umask 022; \
072f4b80 632 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
633};} \
634%{nil}
fb59e475 635
f93109a0 636#-----------------------------------------------------------------
637# Update scrollkeeper database
638# requires: scrollkeeper
639#
640%scrollkeeper_update_post() \
f93109a0 641 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 642%{nil}
f93109a0 643
644%scrollkeeper_update_postun() \
f27cf2fd 645if [ "$1" = "0" ]; then \
f93109a0 646 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 647fi; \
f93109a0 648%{nil}
649
9c404149
AM
650#-----------------------------------------------------------------
651# post %install sequence:
652# - autodeps exceptions
653# - compress all man and info pages,
654# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 655# - compress kernel modules if any
9c404149
AM
656
657###################################################################
658# Requires/Provides automation
3e202b06 659# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 660#
2892b5df
JB
661%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
662%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
663%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
664%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
665%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 666
338726a6
JB
667#%_noautocompressdoc %{nil}
668#
8f74418b
MM
669%_missing_doc_files_terminate_build 1%{nil}
670%_unpackaged_files_terminate_build %{nil}
8781dc74 671# (X)emacs support
d77dcb61 672%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
673%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
674%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 675
02b58f60
JK
676%__php_provides %{nil}
677%__php_requires %{nil}
678%__perl_provides %{nil}
679%__perl_requires %{nil}
fa3497cd 680%__mono_provides %{nil}
681%__mono_requires %{nil}
25043cd4
AF
682
683# Perl specific macro definitions.
c94807f3
ER
684%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
685%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
686%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
687%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
688%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
689%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 690
45c00b39 691# Ruby
c94807f3
ER
692%__ruby /usr/bin/ruby
693%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
694%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
695%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
696%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
697%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
698%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
699%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 700%ruby_rdocdir /usr/share/rdoc
c94807f3 701%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
702%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
703%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 704
7ccf7643 705%php_pear_dir /usr/share/pear
7813c433 706%php_data_dir /usr/share/php
c94807f3
ER
707%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
708%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
709%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 710
0c5d1b9b 711# extract php/zend api versions
c94807f3
ER
712%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
713%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
714%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
715%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
716%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
717%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
718%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
719
720# helper macro
f952c0f3 721%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
722
723# macros for public use
724# for php extensions (php-pecl)
68b68193 725%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 726%{__php_api_requires zend_module_api} \
f952c0f3
ER
727%{__php_api_requires -v %php_major_version debug php_debug} \
728%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 729
c1b2705c
ER
730# for zend extensions
731%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 732%{__php_api_requires zend_extension_api} \
f952c0f3
ER
733%{__php_api_requires -v %php_major_version debug php_debug} \
734%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 735
934c685f
ER
736# for php pdo modules (php-pecl-PDO_*)
737%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
738
6c3b8203
ER
739# for using PHP post scripts. for PHP >= 5.0
740%php_webserver_restart \
741[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 742[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
743if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
744 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
745 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
746 %service -q php-fcgi restart \
747 fi \
748fi \
6c3b8203
ER
749%{nil}
750
751# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
752%php4_webserver_restart \
753[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 754[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
755if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
756 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
757 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
758 %service -q php-fcgi restart \
759 fi \
760fi \
6c3b8203
ER
761%{nil}
762
578e9248 763# X.org helper macros
434ab5a2
ER
764%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
765%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
766
c94807f3
ER
767%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
768%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
769%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
770%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
771%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
578e9248 772
434ab5a2 773%requires_xorg_xserver_extension \
97486460
AM
774%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
775%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
776%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
777%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
778%{nil}
779
780%requires_xorg_xserver_xinput \
97486460
AM
781%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
782%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
783%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
784%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
785%{nil}
786
787%requires_xorg_xserver_font \
97486460
AM
788%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
789%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
790%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
791%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
792%{nil}
793
794%requires_xorg_xserver_videodrv \
97486460
AM
795%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
796%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
797%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
798%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 799%{nil}
578e9248 800
15d7cc4a
ER
801# TCL specific macro definitions.
802# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
803%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
804%tcl_sitearch %{_libdir}/tcl%{tcl_version}
805%tcl_sitelib %{_datadir}/tcl%{tcl_version}
806
25043cd4
AF
807# Python specific macro definitions.
808# python main version
2383a9da 809%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
810
811# directories
2383a9da 812%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 813%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 814%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 815%py_incdir /usr/include/python%{py_ver}
7ccf7643 816%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 817%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 818%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
819
820# pure python modules compilation
3241033b 821%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 822
3241033b 823%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
824
825# Software written in Python language require Python with main version
e63cd81d 826%pyrequires_eq() Requires: %1
25043cd4 827
4bf34b55
AF
828# Python 3.x
829# python main version
830%__python3 python3.0
831%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
832
833# directories
834%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
835%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
836%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
837%py3_incdir /usr/include/python%{py3_ver}
838%py3_sitedir %{py3_libdir}/site-packages
839%py3_sitescriptdir %{py3_scriptdir}/site-packages
840%py3_dyndir %{py3_libdir}/lib-dynload
841
842# pure python modules compilation
843%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
844
845%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
846
f12c2314 847# Hardlink binary identical .pyc and .pyo files
f12c2314 848%__spec_install_post_py_hardlink {\
53d5af13 849%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
850local a b c=0 t=0; \
851if [ -d "$RPM_BUILD_ROOT" ]; then \
852 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
853 while read a; do \
854 b="${a%.pyc}.pyo"; \
855 if cmp -s "$a" "$b"; then \
856 ln -f "$a" "$b"; \
857 c=$((c + 1)); \
858 fi; \
859 t=$((t + 1)); \
860 done < __rpm_pyc; \
861 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
862 rm -f __rpm_pyc; \
863fi; \
53d5af13 864}; __spec_install_post_py_hardlink } }
f12c2314 865
9227b3f9 866# remove python sources, so that check-files won't complain
f12c2314 867%py_postclean() \
0f82e280 868for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 869 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
870done \
871%{nil}
872
4bf34b55
AF
873%py3_postclean() \
874for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
875 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
876done \
877%{nil}
878
0fc5cff8 879# depmod macro
880%depmod() { \
f6148427 881umask 022; \
0fc5cff8 882if [ -e /boot/System.map-%1 ]; then \
3241033b 883 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 884else \
3241033b
ER
885 if [ -e /boot/System.map ]; then \
886 /sbin/depmod -a -F /boot/System.map %1; \
887 else \
888 /sbin/depmod -a %1; \
889 fi \
0fc5cff8 890fi; \
891}
892
2afc6e64 893# XMMS specific macros
c94807f3
ER
894%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
895%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
896%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
897%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
898%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
899%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
900%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
901%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
902%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
903%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
904
905%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
d1537778 906
848c0d68 907# user/group checking macros
908#
909# Usage:
910# %userremove myuser
911#
912%userremove /usr/lib/rpm/user_group.sh user del
913%groupremove /usr/lib/rpm/user_group.sh group del
914#
915# Usage:
916# if %usertestrm myuser; then
917# /usr/sbin/userdel -r myuser
918# Note:
919# use these macros only if you need to call userdel/groupdel with
920# a non-standard option or take an extra action; otherwise use the
921# %userremove/%groupremove macros
922#
923%usertestrm /usr/lib/rpm/user_group.sh user testrm
924%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
925# user group membership management macros
926#
927# Usage:
efbc7726 928# %addusertogroup [-q] myuser agroup
08d9b1f6 929#
efbc7726
ER
930# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
931#
932# Requirements:
933# BuildRequires: rpmbuild(macros) >= 1.515
934%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*
72fcfcb3 935
936# banner support (useful in {pre,post}{,un} and triggers)
937#
938# Usage:
aa41c920 939# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 940# the banner text, the banner text
aa41c920
ER
941# the banner text, and following line
942#EOF
943# You can use any form of here-document, <<'EOF' <<-EOT will do.
944# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
945#
72fcfcb3 946# -a - append to the banner
a8b9562a 947# -e - send to stderr instead of stdout
628754cb 948# -n - no show banner (overrides -t)
949# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
950#
951# Tests:
952# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
953# rpm -E 'date | %banner -e banner' > m; sh -x m
954#
afb54f6c 955%banner(aent:) ( \
1b334fe4 956RPM_SCRIPTVERBOSITY=5 \
957[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
958if [ -x /usr/bin/banner.sh ]; then \
aa41c920 959 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 960else \
a8b9562a 961 CMD="cat%{-e: >&2}" \
1b334fe4 962fi \
276a7b45
ER
963eval $CMD %{?2:%2}%{?3: %3}) \
964%{nil}
628754cb 965
990bd03f 966# useradd/groupadd macros
4c73bc69 967# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
968#
969# Usage:
970# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
971# [-g initial_group] [-G group[,...]] login
972#
973# -u uid. REQUIRED
974# -g gid/group. REQUIRED
975# -s defaults to /bin/false
976# -d defaults to /usr/share/empty
977# -c No default
978# -r is accepted but ignored (it's always set)
6bd4c218 979# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
980# rpm specific flags
981# -P package name. defaults to %{name}
982#
90627280 983%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
984%{!-u:%{error:useradd: Required argument -u missing}} \
985%{!-g:%{error:useradd: Required argument -g missing}} \
986%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
987if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
988 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
989 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
990 exit 1 \
991 fi \
992else \
993 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
994 /usr/sbin/useradd \\\
b5a7d552 995 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
996 -u %{-u*} \\\
997 -r \\\
998 -d %{-d*}%{!-d:/usr/share/empty} \\\
999 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1000 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1001 -g %{-g*} \\\
1002 %{-M} \\\
1003 %{-G:-G %{-G*}} \\\
1aac682a 1004 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1005 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
1006fi;
1007
90627280
ER
1008# Usage:
1009# %groupadd [-P package] [-g gid] group
1010#
1011# -g gid. REQUIRED
1012#
1013# Sample:
1014# %groupadd -P %{name}-base -g %{gid} %{name}
1015
1016%groupadd(g:P:rfo) \
9ba02ba9
ER
1017%{!-g:%{error:groupadd: Required argument -g missing}} \
1018%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1019if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1020 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1021 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1022 exit 1 \
1023 fi \
1024else \
1025 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1026 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1027 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1028fi;
7cb77741 1029
7c50f037 1030# webapp macros
4c73bc69 1031# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1032#
1033# The config is installed/removed inside trigger, this means that you can any
1034# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1035# updated. if you don't need the config for various reason for specific
35663282
ER
1036# webserver, just remove the symlink from config directory using webapp
1037# program. the trigger will not recreate the symlink on upgrades. In other
1038# words the config is linked to webserver config directory on first install of
1039# PACKAGE or WEBSERVER.
1040#
7c50f037
ER
1041# Add package's webserver config to webserver webapps dir.
1042# Usage:
df979130 1043# %webapp_register WEBSERVER WEBAPP
35663282
ER
1044#
1045%webapp_register() \
1046%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1047if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1048 /usr/sbin/webapp register %1 %2\
1049fi\
694a8f2e 1050# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1051if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1052 %{expand:%service -q %%1 reload}\
35663282
ER
1053fi\
1054%{nil}
1055
1056# Remove package's config from webserver webapps dir.
35663282 1057# Usage:
531c0efc
ER
1058# %webapp_register [-f] WEBSERVER WEBAPP
1059%webapp_unregister(f) \
35663282
ER
1060%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1061# remove link if either of the packages are gone \
5d3a09a3 1062if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1063 /usr/sbin/webapp unregister %1 %2\
16897aea 1064 %{expand:%service -q %%1 reload}\
35663282
ER
1065fi \
1066%{nil}
1067
462b26fa 1068# service macro.
4c73bc69 1069# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1070#
1071# calls usual service restart on package %post, but skips the restart if
1072# administrator has disabled automatic service restarts in either global
1073# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1074#
462b26fa 1075# Usage:
7377b5ca 1076# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1077#
a0bbe604 1078# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1079# -n NOOP mode, do not actually restart service
462b26fa 1080#
7377b5ca
ER
1081# Requirements:
1082# BuildRequires: rpmbuild(macros) >= 1.268
1083# Requires: rc-scripts
1084# -n option:
1085# BuildRequires: rpmbuild(macros) >= 1.450
1086%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1087
1088
f9aa75bf
ER
1089# Java macros. based on jpackage macros.java
1090#
1091# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1092%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1093
1094# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1095%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1096
1097# Root directory for all Java VM/SDK/JRE's private things.
1098%_jvmprivdir %{_libdir}/jvm-private
1099
1100# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1101%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1102
1103# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1104%_jvmdatadir %{_datadir}/jvm
1105
1106# Root directory for all configurations parts of Java VM/SDK/JRE's
1107%_jvmsysconfdir %{_sysconfdir}/jvm
1108
1109# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1110%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1111
1112# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1113%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1114
1115# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1116%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1117
1118# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1119%_jnidir %{_libdir}/java
f9aa75bf 1120
c94807f3 1121%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1122
a9254650 1123%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1124%jar %{java_home}/bin/jar
c94807f3 1125%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1126%javac %{java_home}/bin/javac
1127%javadoc %{java_home}/bin/javadoc
6aedae62 1128
fe6c4bdd 1129%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1130
1131%jpackage_script() \
3ca65b87
ER
1132install -d $RPM_BUILD_ROOT%{_bindir}\
1133cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1134#!/bin/sh\
1135#\
1136# %{name} script\
1137# JPackage Project <http://www.jpackage.org/>\
1138\
1139# Source functions library\
1140. %{_javadir}-utils/java-functions\
1141\
1142# Source system prefs\
3ca65b87 1143if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1144 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1145fi\
1146\
1147# Source user prefs\
3ca65b87
ER
1148if [ -f $HOME/.%{name}rc ]; then\
1149 . $HOME/.%{name}rc\
6aedae62
ER
1150fi\
1151\
1152# Configuration\
1153MAIN_CLASS=%1\
1154BASE_FLAGS=%2\
1155BASE_OPTIONS=%3\
3ca65b87 1156BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1157\
1158# Set parameters\
1159set_jvm\
3ca65b87
ER
1160set_classpath $BASE_JARS\
1161set_flags $BASE_FLAGS\
1162set_options $BASE_OPTIONS\
6aedae62
ER
1163\
1164# Let's start\
3ca65b87 1165run "$@"\
6aedae62
ER
1166EOF
1167
06f11871
ER
1168# jpackage 1.7
1169# Directory for maven depmaps
1170#
1171%_mavendepmapdir /etc/maven
1172%_mavendepmapfragdir /etc/maven/fragments
1173
1174#
1175# add_to_depmap adds an entry to the depmap. The arguments are:
1176#
1177# %1 the original groupid
1178# %2 the original artifact id
1179# %3 the version
1180# %4 the new groupid
1181# %5 the new artifactid
1182#
1183
1184%add_to_maven_depmap() \
1185install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1186cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1187<dependency>\
1188 <maven>\
1189 <groupId>%1</groupId>\
1190 <artifactId>%2</artifactId>\
1191 <version>%3</version>\
1192 </maven>\
1193 <jpp>\
1194 <groupId>%4</groupId>\
1195 <artifactId>%5</artifactId>\
1196 <version>%3</version>\
1197 </jpp>\
1198</dependency>\
1199\
1200EOF\
1201%{nil}
1202
1203#==============================================================================
1204#
1205# update_maven_depmap updates the main maven depmap
1206#
1207%update_maven_depmap() \
1208echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1209if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1210cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1211fi\
1212echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1213
1214
59d3ebe9 1215# PEAR install macros
4c73bc69 1216# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1217#
1218# Usage:
f7ecf326 1219# %%pear_package_setup ...
dfce8b19 1220#
59d3ebe9 1221# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1222# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1223# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1224# -D - pass -D to %setup (so the build dir is not removed)
1225# -c - register channel from local channel.xml file
dfce8b19
ER
1226#
1227# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1228# destination hierarchy. you should copy the tree to buildroot after
1229# patching/reorganizing with %%pear_package_install.
1230#
1231# additionally BUILDROOT is stripped from files and files are converted to UNIX
1232# line endings.
1233#
1234# the pear install process output is recorded to install.log, you should put it
8763f51e 1235# to %%doc for later debug or just for information.
dfce8b19
ER
1236#
1237# additionally additional-packages.txt is produced if it was detected that the
1238# package has optional dependencies. the file format is suitable of displaying
1239# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1240# automatically added for this file.
59d3ebe9
ER
1241
1242
1243# records install.log and transforms PEAR names to PLD Linux rpm package names.
1244%__pear_install_log \
1245tee install.log \
1246# make post message of optional packages \
f64d1bb2 1247grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1248if [ -s optional-packages.txt ]; then \
1249 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1250else \
1251 rm -f optional-packages.txt \
1252fi \
1253%{nil}
1254
1255# command invoking pear cli
1256%__pear /usr/bin/pear
1257
67a089ff 1258%pear_install(a:n:zD) \
59d3ebe9 1259%__pear \\\
f7ecf326 1260 -c %{builddir}/pearrc \\\
dfce8b19 1261 -d doc_dir=/docs \\\
f7ecf326
ER
1262 -d temp_dir=/tmp \\\
1263 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1264 -d bin_dir=%{_bindir} \\\
1265 -d data_dir=%{php_pear_dir}/data \\\
1266 -d test_dir=%{php_pear_dir}/tests \\\
1267 install \\\
59d3ebe9 1268 --packagingroot=%{builddir} \\\
dfce8b19
ER
1269 --offline \\\
1270 --nodeps \\\
1271 %{-f:--force} \\\
67a089ff 1272 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1273 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1274%{nil}
1275
1276# The main macro.
1277# using this macro will append optional-packages.txt to the nocompressdoc list
1278# as it's displayed to user after package install. and adding additional gzip
1279# dep is just waste ;)
f7ecf326 1280%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1281%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1282%define builddir %{_builddir}/%{srcdir} \
1283%setup -q -c -T %{-D:-D} -n %{srcdir} \
1284%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1285%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1286%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1287%pear_install \
59d3ebe9
ER
1288%{-z:cd ..} \
1289cat %{-z:$_N/}.install.log | %__pear_install_log \
1290\
dfce8b19 1291# undos sources \
2a80e4cf 1292find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1293%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1294%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1295%{nil}
1296
7bef60e8 1297# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1298# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1299%pear_package_install() \
1300cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1301find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1302# help the developer out a little: \
1303if [ -f _noautoreq ]; then \
1304 echo "AutoReqdep detected:" \
1305 echo "_noautoreq $(cat _noautoreq)" \
1306fi \
1307%{nil}
1308
0d5dd00c
ER
1309
1310# Register OpenLDAP schema.
4c73bc69 1311# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1312#
1313# Usage:
1314# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1315#
1316# -d specify dependant schemas, separated by comma
1317#
1318%openldap_schema_register(d:) \
1319for schema in %*; do \
1320 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1321 %{__sed} -i -e " \
1322 /^include.*local.schema/{ \
1323 iinclude\\t $schema\
1324 } \
1325 " /etc/openldap/slapd.conf \
1326 fi \
1327done \
1328# enable dependant schemas \
1329if [ "%{-d*}" ]; then \
1330 %{__sed} -i -e ' \
1331 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1332 s/^#// \
1333 }' /etc/openldap/slapd.conf \
1334fi \
1335%{nil}
1336
1337# Unregister OpenLDAP schema.
4c73bc69 1338# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1339#
1340# Usage:
1341# %%openldap_schema_unregister %{schemadir}/horde.schema
1342#
1343%openldap_schema_unregister() \
1344for schema in %*; do \
1345 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1346 %{__sed} -i -e " \
1347 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1348 # for symmetry it would be nice if we disable enabled schemas in post, \
1349 # but we really can not do that, it would break something else. \
1350 " /etc/openldap/slapd.conf \
1351 fi \
1352done \
1353%{nil}
1354
b0bc2936 1355%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1356
dcc6baf7 1357
1358# Build modules for kernels 2.6
1359# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1360#
1361# Usage:
aa559e46 1362# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1363#
1364# remember that proper Makefile is still required
1365# Options:
990bd03f 1366# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1367# without .ko extension, may be placed in subdirectory
aa559e46 1368# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1369# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1370# -c -- do not execute make clean
dcc6baf7 1371# <additional arguments> -- all additional arguments will be passed to
1372# make modules
1373#
1374# Additional patching supported via here document. Try:
1375# %build_kernel_modules -m module <<'EOF'
1376# your patch script here
1377# EOF
1378# Don't use it unless patching depends on config options.
1379
1380# Developer note: don't touch it unless you know how to handle '\'.
1381# - \ in script expands to nothing
1382# - \\\ in script expands to \
566398b4 1383# - \\\ inside definition expands to nothing
dcc6baf7 1384# - \\\\\\\ inside definition expands to \
1385# - in last line \ has to touch arguments so arguments passing
1386# in new lines (using \) will be supported
1387
5a81d83e 1388%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1389%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1390 \
1391%define Opts \\\\\\\
1392%if "%{_target_base_arch}" != "%{_arch}" \\\
1393 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1394 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1395 %else \\\
1396 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1397 %endif \\\
1398%else \\\
88608ef7 1399 CC="%{kgcc}" \\\
dcc6baf7 1400%endif \
88608ef7 1401%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1402 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1403 \
e364bc26 1404%{?-C:cd %{-C*}} \
dcc6baf7 1405compile() { \
ba9de9b2
ER
1406 local L="<" PATCH_SH; \
1407 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1408 set -e -x \
730239f9 1409 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1410 \
730239f9 1411for cfg in ${cfgs:-dist}; do \
dcc6baf7 1412 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1413 \
c546f6fb 1414 rm -rf o \
68cfe9d9 1415 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1416 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1417 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1418 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1419 \
1420 set +x \
1421 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1422 set -x \
1423 \
c768535c 1424 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1425 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1426 %{-p*} %{-P*} \\\
1427 %{MakeOpts} \
1428 %else \
1429 install -d o/include/config \
1430 touch o/include/config/MARKER \
588f1b0b 1431 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1432 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1433 %endif \
1434 \
5a81d83e 1435 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1436 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1437 ${1+"$@"} \\\
5a81d83e 1438 M=$PWD %{MakeOpts}} \
f635907b 1439 \
dcc6baf7 1440 %{__make} -C %{_kernelsrcdir} modules \\\
1441 ${1+"$@"} \\\
1442 M=$PWD %{MakeOpts} \
1443 \
1444 for MODULE in {%{-m*},}; do \
1445 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1446 done \
1447done \
aa559e46 1448%{?-C:cd -} \
dcc6baf7 1449} \
1450compile %{*}\
1451%{nil}
1452
1453
1454# Install kernel modules built by %build_kernel_modules
1455# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1456#
1457# Usage:
1458# %install_kernel_modules -m <modules> -d <directory>
1459#
1460# Options:
990bd03f 1461# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1462# without .ko extension, may be placed in subdirectory
1463# -d <directory> (required) -- in what subdirectory modules should be
1464# installed (eg. misc, kernel/drivers/net)
1465# -s <suffix> -- suffix to use when installing modules, useful when module
1466# with same name exists in kernel already
1467# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1468# for defining aliases, only useful with -s
dcc6baf7 1469
1470%install_kernel_modules(m:d:s:n:) \
1471%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1472%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1473%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1474 \
1475%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1476%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1477 \
b279feda 1478__install_kernel_modules() { \
730239f9 1479local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1480 \
1481for MODULE in {%{-m*},}; do \
1482 [ -n "${MODULE}" ] || continue \
730239f9
ER
1483 for cfg in ${cfgs:-dist}; do \
1484 [ "$cfg" = smp ] && suf=smp || suf= \
1485 MNAME=${MODULE##*/} \
1486 install -D ${MODULE}-$cfg.ko \\\
1487 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1488 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1489 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1490 >> %{ModprobeD}$suf/%{-n*}.conf} \
1491 done \
dcc6baf7 1492done \
b279feda 1493} \
1494__install_kernel_modules \
dcc6baf7 1495%{nil}
1496
fa65356c 1497# patchset macros
4c73bc69 1498# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1499#
1500# Usage:
1501# %patchset_source -f <seq(1) format> <start> [<end>]
1502# %patchset_patch <start> [<end>]
1503#
1504# If <end> is omited, it is assumed to be <start>.
1505#
1506# For example in preamble:
1507# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1508# and in %prep:
1509# %patchset_patch 33 44
1510
1511# generate SourceX urls from range START STOP
1512# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1513# The sources start from 10000
e91610db 1514%patchset_source(f:b:) %(
44f733ef 1515 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1516 start=$(expr $base + %1);
1517 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1518 # we need to call seq twice as it doesn't allow two formats
1519 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1520 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1521 paste %{tmpdir}/__ps{1,2};
1522 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1523) \
1524%{nil}
fa65356c
ER
1525
1526# apply sources from %patchset_source
1527# -p specify -pX for %patch line
1528# -b base offset: defaults to 10000
1529%patchset_patch(f:p:b:) %(
44f733ef 1530 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1531 start=$(expr $base + %1);
1532 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1533 echo ": patchset_patch %1%{?2: to %2}";
1534 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1535) \
1536%{nil}
fa65356c 1537
5730b44b 1538# browser plugins v2
4c73bc69 1539# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1540#
1541# Usage:
1542# %browser_plugins_add_browser <name> -p <plugindir>
1543#
1544# <name> (required) -- name of the browser. usually %{name}.
1545# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1546# -b -- default blacklists
1547# -a <arch> override arch
5730b44b
ER
1548#
1549# Example:
1550# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1551
1552%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1553%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1554%update_browser_plugins /usr/sbin/update-browser-plugins || :
1555
02ebf70f 1556%browser_plugins_add_browser(p:b:a:) \
9efd458e 1557 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1558 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1559 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1560 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1561 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1562 %{-b:cat >> $blacklist_file %{-b*}} \
1563%{nil}
1564
ad17b654
ER
1565# Helper for LUA.
1566# split string separated by space into quoted list
1567#
4c73bc69 1568# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1569#
1570# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1571%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1572
1573# adjust /etc/shells by adding and removing shells from there
4c73bc69 1574# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1575#
1576# Usage:
d9b789d9
ER
1577# %post -p <lua>
1578# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1579#
d9b789d9
ER
1580# %preun -p <lua>
1581# if arg[2] == 0 then
1582# %lua_remove_etc_shells /bin/bash /bin/rbash
1583# end
7377b5ca
ER
1584#
1585# Requirements:
d9b789d9
ER
1586# BuildRequires: rpmbuild(macros) >= 1.462
1587#
ad17b654 1588
d9b789d9 1589%lua_add_etc_shells() \
ad17b654
ER
1590t = {}\
1591f = io.open("/etc/shells", "r")\
1592if f then\
1593 for l in f:lines() do t[l]=l; end\
1594 f:close()\
1595end\
1596for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1597 if not t[s] then\
b8c0bc18 1598 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1599 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1600 end\
1601end\
1602%{nil}
1603
d9b789d9
ER
1604%lua_remove_etc_shells() \
1605t = {}\
1606f = io.open("/etc/shells", "r")\
1607if f then\
1608 for l in f:lines() do t[l]=l; end\
1609 f:close()\
1610end\
1611for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1612 print("Removing "..l.." from /etc/shells")\
1613 t[l] = nil\
1614end\
1615s=""\
1616for _, l in pairs(t) do\
1617 s=s..l.."\\n"\
1618end\
1619io.open("/etc/shells", "w"):write(s)\
1620%{nil}
1621
1622# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1623#
1624# Author: Elan Ruusamäe <glen@pld-linux.org>
1625#
1626# Usage:
1627# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1628# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1629#
1630# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1631#
1632# Requirements:
1633# BuildRequires: rpmbuild(macros) >= 1.429
1634#
1635%add_etc_shells(p) %{-p:<lua>}\
1636%{expand:%%lua_add_etc_shells %*}\
1637%{nil}
1638
ad17b654 1639%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1640%{-p:if arg[2] == 0 then}\
d9b789d9 1641%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1642%{-p:end} \
ad17b654
ER
1643%{nil}
1644
75bd6249
ER
1645# Check syntax for Python files
1646#
1647# Author: Elan Ruusamäe <glen@pld-linux.org>
1648# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1649#
1650# Usage:
1651# %py_lint src
1652#
1653# Requirements:
1654# BuildRequires: python
1655# BuildRequires: rpmbuild(macros) >= 1.469
1656
1657%py_lint() \
1658__py_lint() { \
1659find "$@" -type f -name '*.py' | python -c ' \
1660import sys \
1661import compiler \
1662\
1663err = 0\
1664for f in sys.stdin: \
1665 fd = open(f.strip()) \
1666 c = fd.read() \
1667 fd.close() \
1668 try: \
1669 compiler.parse(c) \
1670 except SyntaxError, e: \
1671 print "py_lint: %s: %s" % (f.strip(), e) \
1672 err = err + 1\
1673\
1674if err: \
1675 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1676 sys.exit(1) \
1677else: \
1678 print >> sys.stderr, "py_lint: Found no syntax errors." \
1679' \
1680}; __py_lint %* \
1681%{nil}
1682
59d3ebe9 1683# vim:ts=4 sw=4 noet syn=spec
This page took 5.39803 seconds and 4 git commands to generate.